/* benaphore.h
**
*/
#pragma once

//
// OBS: must use shared memory for inter-team benaphores!
//

struct benaphore_t {
	sem_id	sem;
	long	atom;
};


inline benaphore_t& create_benaphore(char *name)
{
	benaphore_t ben;
	ben.atom = 0;
	ben.sem = create_sem(0, name);
	return ben;
}

inline long create_benaphore(benaphore_t *ben, char *name)
{
	ben->atom = 0;
	return ben->sem = create_sem(0, name);
}

#define acquire_benaphore(ben) do { \
	if (atomic_add(&ben.atom, 1) > 0) { \
		acquire_sem(ben.sem); \
	} \
} while (0)

#define release_benaphore(ben) do { \
	if (atomic_add(&ben.atom, -1) > 1) { \
		release_sem(ben.sem); \
	} \
} while (0)


#ifdef NOTDEFINED

inline void acquire_benaphore(long *atom, sem_id sem)
{
	if (atomic_add(&ben.atom, 1) > 0) {
		acquire_sem(ben.sem);
	}
}

inline void release_benaphore(benaphore &ben)
{
	if (atomic_add(ben.atom, -1) > 1) {
		release_sem(ben.sem);
	}
}

inline void acquire_benaphore_etc(benaphore ben)
{
	if (atomic_add(ben.atom, 1) > 0) {
		acquire_sem(ben.sem, );
	}
}

inline void signal_benaphore(benaphore ben)
{
	if (atomic_set(ben.atom, 1) > 1) {
		release_sem(ben.sem);
	}
}
#endif
